/*
 * EngineUI.java
 *
 * Created on June 21, 2007, 12:07 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package batch;
import sim.portrayal.continuous.*;
import sim.portrayal.simple.*;
import sim.display.*;
import sim.engine.*;
import sim.util.*;
import javax.swing.*;
import java.awt.*;

/**
 *
 * @author Edward
 */
public class EngineUI extends GUIState {
    public Display2D display;
    public JFrame displayFrame;
    
    ContinuousPortrayal2D agentPortrayal = new ContinuousPortrayal2D();
    
    public static void main(String[] args) {
        EngineUI sim = new EngineUI();
        Console console = new Console(sim);
        console.setVisible(true);
    }
    
    /** Creates a new instance of EngineUI */
    public EngineUI() {
        super(new Engine(System.currentTimeMillis()));
    }
    
    public EngineUI(SimState state) {
        super(state);
    }
    
    public static String getName() {
        return("Batch package");
    }
    
    @Override
    public Object getSimulationInspectedObject() {return state;}

    public ContinuousPortrayal2D getAgentPortrayal() {
        return agentPortrayal;
    }
    
    @Override
    public void start() {
        super.start();
        setupDrawing();
    }
    
    public void load() {
        super.load(state);
        setupDrawing();
    }
    
    @Override
    public void quit() {
        super.quit();
        if (displayFrame!=null) displayFrame.dispose();
        displayFrame = null;
        display = null;
    }
    
    public void setupDrawing() {
        Engine blah = (Engine) state;
        agentPortrayal.setField(((Engine)state).agentsEnvironment);
        
        display.reset();
        display.repaint();
    }
    
    public Display2D getDisplay() {return display;}
    
    @Override
    public void init (Controller c) {
        super.init(c);
        
        display = new Display2D(600,600,this,1);
        display.setBackdrop(Color.black);
        display.attach(agentPortrayal,"Moving thingy");
        
        displayFrame = display.createFrame();
        c.registerFrame(displayFrame);
        displayFrame.setVisible(true);
    }
       
}
