/*
 * Neutro.java
 *
 * Created on June 27, 2007, 2:14 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package batch;
import java.awt.*;
import sim.engine.*;
import sim.util.*;

/**
 * @author Edward
 */
public class Neutro extends Agent implements Steppable{
    public int lifespan;
    public int age;
    //Number of timesteps between apoptosis and secondary necrosis
    public int sellByDate = 300;
    
    //Methods to output values to GUI interface
    public boolean getApoptotic() {return apoptotic;}
    public boolean getEdible() {return edible;}
    public int getLifespan() {return lifespan;}
    public int getSellByDate() {return sellByDate;}
    
    /** Creates a new instance of Neutro*/
    public Neutro(double v, double a, int l) {
        super (v,a);
        lifespan = l;
        diam = 3;
        agentCol = Color.lightGray;
        age = 0;
        setState(agentCol, diam);
    }
       
    /**Apoptosis method: change colour to red and apoptotic flag to true*/
    void apoptose() {
        setState(Color.red, diam);
        apoptotic = true;
    }
    
    /**Get opsonised by collectin molecule: change colour to blue and set
     edible flag to true*/
    void bindReceptor() {
        edible = true;
        setState(Color.blue, diam);
    }
    
    /**Necrosis method: set colour to green and edible to true*/
    void goNecrotic() {
        edible = true;
        setState(Color.green, diam);
        necrotic = true;
    }
    
    /**Methods called each timestep*/
    public void step (SimState state) {
        if (!dead) {
            Engine simulation = (Engine) state;
            age++;
            //Apoptose after specified time period
            if (age == lifespan) {
                apoptose();
                simulation.numApop++;
                simulation.numLive--;
            }
            //If apoptotic, become opsonised with percentage probability opsoninLevel
            if (apoptotic && !edible && simulation.random.nextBoolean(simulation.opsoninLevel/100.0)) {
                bindReceptor();
                simulation.numApop--;
                simulation.numBound++;
            }
            //Become necrotic after specified period of time
            if (age == lifespan+sellByDate) {
                goNecrotic();
                simulation.makeNeutro();
                if (edible) {
                    simulation.numBound--;
                    simulation.numNecrotic++;
                }
                if (!edible) {
                    simulation.numApop--;
                    simulation.numNecrotic++;
                }
            }
            moveAgent();
            simulation.setObjectLocation(this, loc);
            simulation.collision(this);
        }
    }
    
}
