/*
 * StemCell.java
 *
 * Created on July 8, 2007, 5:05 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package batch;
import sim.engine.*;

/**
 *
 * @author Edward
 */
public class StemCell implements Steppable {
    double RBeta = 0;
    double RAlpha = 0;
    double NBeta = 100;
    double NAlpha = 100;
    double kBeta1 = 0.00185;
    double kBeta2 = 0.5;
    double kAlpha1 = 0.00278;
    double kAlpha2 = 0.5;
    
    double neutroProb = 0.0001;
    double kHom = 0.001;
    
    double maxProb = 0.05;
    
    /** Creates a new instance of StemCell */
    public StemCell() {
    }
    
    void findNoSignalReceptors(double CBeta, double CAlpha) {
        RBeta += kBeta1*CBeta*(1 - (RBeta/NBeta)) - kBeta2*(RBeta/NBeta);
        RAlpha += kAlpha1*CAlpha*(1 - (RAlpha/NAlpha)) - kAlpha2*(RAlpha/NAlpha);
    }
    
    void calculateNeutroProb() {
        neutroProb = maxProb*kHom*(1+((1-kHom)/kHom)*(RAlpha/NAlpha) - (RBeta/NBeta));
    }
    
    public void step(SimState state) {
        Engine simulation = (Engine) state;
        if (simulation.schedule.time()%50 == 0){
            simulation.writeOutputData();
        }
        if (simulation.schedule.time()==2500) {
            simulation.spikeConcentration();
        }
        findNoSignalReceptors(simulation.CBeta, simulation.CAlpha);
        calculateNeutroProb();
        simulation.neutroProb = this.neutroProb;
        if (simulation.random.nextBoolean(simulation.neutroProb)) {
            simulation.makeNeutro();
        }
        if (simulation.schedule.time() >= 5010) {
            simulation.finish();
        }
        
    }
    
}
